var nvsCaptionNumberer = (function() {
	var instance = {};

	var $imageCaptionList;
	var $tableCaptionList;
	var $videoCaptionList;

	// captions in main blocks area
	instance.enumerateCaptions = function() {
		$imageCaptionList = $('.xblocks .js-image-caption-counter');
		$tableCaptionList = $('.xblocks .js-table-caption-counter');
		$videoCaptionList = $('.xblocks .js-video-caption-counter');

		$imageCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$tableCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$videoCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
	}

	// captions in presentation slider
	instance.enumeratePresentationCaptions = function() {
		$imageCaptionList = $('.presentation .js-image-caption-counter');
		$tableCaptionList = $('.presentation .js-table-caption-counter');
		$videoCaptionList = $('.presentation .js-video-caption-counter');

		$imageCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$tableCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$videoCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
	}

	function construct() {
		instance.enumerateCaptions();
		instance.enumeratePresentationCaptions();
	}

	return {
		init: function() {
			construct();

			return instance;
		}
	};
})();
var nvsGlosarry = (function() {


  var instance = {};

  // public



  function construct() {


    if ($('.nvs-popper-window').length == 0) {
      $('body').append('<div class="nvs-popper-window"><button class="glossary__close js-nvs-popper-window-close" type="button"><span class="icon"><svg class="icon-close"><use xlink:href="#close"></use></svg></span></button><div class="popper__content"></div><div class="popper__arrow"></div></div>');
    }


    $('.js-nvs-popper-window-close').on('click', function() {
      popover.hide();
    });


    var reference = $('.nvs-tooltip');
    var popover = $('.nvs-popper-window');
    popover.hide();

    $(document).on('click touchend', function(e) {
      var target = $(e.target);
			
      // ne need to reshow and recreate poper when click over popup so return;
      if (target.is(popover)) return;

      if (target.is(reference)) {
        e.preventDefault();

        var html = '<div class="' + target.data('tooltip-class') + '"><h3>' + target.data('tooltip-term') + '</h3><div class="tooltip-body">' + target.data('tooltip-description');

        if (target.data('tooltip-link') !== '') {
          html += '<a href="' + target.data('tooltip-link') + '" class="glossary__link">' + window['pkc-locales'][document.documentElement.lang].glossary + '</a>';
        }

        html += '</div></div>';

        popover.children('.popper__content').html(html);
        popover.show();

        // notify analytics
        let anal = {
          block: target.attr('data-tooltip-id'),
          component: 'glossary-popup',
          verb: 'opened'
        };

        const ev = new CustomEvent('izzi:analytics', { detail: anal });
        window.dispatchEvent(ev);

        var popper = new Popper(target, popover, {
          placement: 'bottom'
        });

      }
      else {
        popover.hide();
      }

    });
  }

  return {
    init: function() {
      construct();

      return instance;
    }
  };
})();

$.fn.isOnScreen = function () {

  var win = $(window);

  var viewport = {
    top: win.scrollTop(),
    left: win.scrollLeft()
  };
  viewport.right = viewport.left + win.width();
  viewport.bottom = viewport.top + win.height();

  var bounds = this.offset();
  bounds.right = bounds.left + this.outerWidth();
  bounds.bottom = bounds.top + this.outerHeight();

  return (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));

};

// echo in console
var nvsDebug = false;

//hashCode

String.prototype.hashCode = function() {
  var hash = 0, i, chr;
  if (this.length === 0) return hash;
  for (i = 0; i < this.length; i++) {
    chr   = this.charCodeAt(i);
    hash  = ((hash << 5) - hash) + chr;
    hash |= 0; // Convert to 32bit integerve
  }
  return hash;
};



//\\//\\//\\//\\//\\//
//\\Document ready\\//
//\\//\\//\\//\\//\\//
jQuery(document).ready(function () {

  // mobile app send sid to DOS through localStorage
  if(localStorage.getItem('nvsSid')) {
    document.cookie = 'PHPSESSID='+localStorage.getItem('nvsSid')+'; expires=31 Dec 2030 23:59:59 UTC; path=/';
  }

}); //end document ready



//\\//\\//\\//\\//\\//
//\\Document load \\//
//\\//\\//\\//\\//\\//




//detect touch
window.addEventListener('touchstart', function onFirstTouch() {

  // we could use a class
  document.body.classList.add('touchstart', 'has-touch');

  // or set some global variable
  window.USER_IS_TOUCHING = true;

  // we only need to know once that a human touched the screen, so we can stop listening now
  window.removeEventListener('touchstart', onFirstTouch, false);
}, false);

